/*
  Analog input, analog output, serial output

  Reads an analog input pin, maps the result to a range from 0 to 255 and uses
  the result to set the pulse width modulation (PWM) of an output pin.
  Also prints the results to the Serial Monitor.

  The circuit:
  - potentiometer connected to analog pin 0.
    Center pin of the potentiometer goes to the analog pin.
    side pins of the potentiometer go to +5V and ground
  - LED connected from digital pin 9 to ground

  created 29 Dec. 2008
  modified 9 Apr 2012
  by Tom Igoe

  This example code is in the public domain.

  http://www.arduino.cc/en/Tutorial/AnalogInOutSerial
*/

// These constants won't change. They're used to give names to the pins used:
const int x_Pin = A1;  // Analog input pin that the potentiometer is attached to
const int y_Pin = A2;  // Analog input pin that the potentiometer is attached to
const int taste = 4;
const int blau = 5;
const int gruen =6;
const int gelb = 7;
const int rot = 8;
const int weiss = 9;
const int home_xy=10;
const int home_z=11;
const int reset_coordinates=12;


boolean z_axis = false;
boolean hxy = false;
boolean hz = false;
boolean rc = false;


const int button_Pin = 4; // Analog output pin that the LED is attached to

int x=0;
int y=0;
int z=0;
int t=0;
String X_command = "X-000.0 F200";
String Y_command = "Y-000.0 F200";
String Z_command = "Z-000.0 F200";
String vorschub = "100.10 ";
int toggle=5;

void setup() {
  // initialize serial communications at 9600 bps:
  Serial.begin(250000);
  pinMode(blau, OUTPUT);
  pinMode(gruen, OUTPUT);
  pinMode(gelb, OUTPUT);
  pinMode(rot, OUTPUT);
  pinMode(weiss, OUTPUT);
  pinMode(taste, INPUT_PULLUP);
  pinMode(home_xy, INPUT_PULLUP);
  pinMode(home_z, INPUT_PULLUP);
  pinMode(reset_coordinates, INPUT_PULLUP);
  
  digitalWrite(blau, HIGH);   
  digitalWrite(gruen,HIGH);   
  digitalWrite(gelb, HIGH);   
  digitalWrite(rot, HIGH);
  digitalWrite(weiss, HIGH);   
  delay(1000);                       // wait for a second
  digitalWrite(blau, LOW);   
  digitalWrite(gruen, LOW);   
  digitalWrite(gelb, LOW);   
  digitalWrite(rot, LOW);  
  digitalWrite(weiss, LOW); 
  
  delay(1000);;
                    
}

void loop() {
  // read the analog in value:
  x = analogRead(x_Pin);
  y = analogRead(y_Pin);
  hxy = digitalRead(home_xy);
  hz = digitalRead(home_z);
  rc = digitalRead(reset_coordinates);
  
  
  t = digitalRead(taste);
  if (t==LOW)
  {
    toggle=toggle+1;
    if (toggle==9)
    {toggle=5;
    z_axis = !(z_axis);}
    
 }
  
  switch(toggle) {
    case 5:
      vorschub="0.10 ";
      break;
    case 6: 
      vorschub="1.0 ";
      break;  
    case 7: 
      vorschub="10.0 ";
      break;  
    case 8: 
      if (z_axis)
      {
      vorschub="20.0 ";
      }
      else
      {
        vorschub="100.0 ";
        };
      break;  
    
  }
  x = map(x, 0,1020, 1, -1);
  y = map(y, 0, 1020, -1, 1);
  z = y;
    digitalWrite(weiss, z_axis);
    digitalWrite(blau, LOW);   
    digitalWrite(gruen, LOW);   
    digitalWrite(gelb, LOW);   
    digitalWrite(rot, LOW); 
    digitalWrite(toggle,HIGH);
  switch (x) {
    case -1:
      X_command = String(" X-" + vorschub);
      break;
    
    case 1:
      X_command = String(" X" + vorschub);
      break;
      
    default:
      X_command =" X0 ";
      // default is optional
    break;
  }
  
switch (y) {
    case -1:
      Y_command = String(" Y-" + vorschub);
      break;
    case 1:
      Y_command = String(" Y" + vorschub);
      break;
      
    default:
      Y_command =" Y0 ";
      // default is optional
    break;
  }



switch (z) {
    case -1:
      Z_command = String(" Z-" + vorschub);
      break;
    case 1:
      Z_command = String(" Z" + vorschub);
      break;
      
    default:
      Z_command =" Z0 ";
      // default is optional
    break;
  }
 if (Y_command==" Y0 " && X_command==" X0 ") 
 {
   }
 else
 {
  if (z_axis) 
   {
   switch (z) {
    case 0:
    break;
    default:
    {
   
   Serial.println("G91");
  Serial.print("G1");
  Serial.print(Z_command);
  Serial.println("F1000");
  Serial.println("G90");
  Serial.println("M114");
  Serial.flush();
   }; 
   }
   }
   else
  {
  Serial.println("G91");
  Serial.print("G1");
  Serial.print(X_command);
  Serial.print(Y_command);
  Serial.println("F1000");
  Serial.println("G90");
  Serial.println("M114");
  Serial.flush();
  }
 }
 if (!(hxy)) 
 {Serial.println("G28 X Y");
  Serial.println("M117 Home XY...");
  delay(1000);
 }; 
 
 if (!(hz))
 {Serial.println("G28 Z");
  Serial.println("M117 Home Z...");
  delay(1000);
 };
 
 if (!(rc)) 
  {Serial.println("G92 X0 Y0 Z0");
   Serial.println("M300 S300 P1000");
   Serial.println("M117 Reset coordinates");
   delay(1000);
  }
 
  // wait 500 milliseconds before the next loop 
  delay(350);
}
